﻿/**
* Copyright 2010 Tim Down.
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
*
*      http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
*/
var Hashtable = (function () { var p = "function"; var n = (typeof Array.prototype.splice == p) ? function (s, r) { s.splice(r, 1) } : function (u, t) { var s, v, r; if (t === u.length - 1) { u.length = t } else { s = u.slice(t + 1); u.length = t; for (v = 0, r = s.length; v < r; ++v) { u[t + v] = s[v] } } }; function a(t) { var r; if (typeof t == "string") { return t } else { if (typeof t.hashCode == p) { r = t.hashCode(); return (typeof r == "string") ? r : a(r) } else { if (typeof t.toString == p) { return t.toString() } else { try { return String(t) } catch (s) { return Object.prototype.toString.call(t) } } } } } function g(r, s) { return r.equals(s) } function e(r, s) { return (typeof s.equals == p) ? s.equals(r) : (r === s) } function c(r) { return function (s) { if (s === null) { throw new Error("null is not a valid " + r) } else { if (typeof s == "undefined") { throw new Error(r + " must not be undefined") } } } } var q = c("key"), l = c("value"); function d(u, s, t, r) { this[0] = u; this.entries = []; this.addEntry(s, t); if (r !== null) { this.getEqualityFunction = function () { return r } } } var h = 0, j = 1, f = 2; function o(r) { return function (t) { var s = this.entries.length, v, u = this.getEqualityFunction(t); while (s--) { v = this.entries[s]; if (u(t, v[0])) { switch (r) { case h: return true; case j: return v; case f: return [s, v[1]] } } } return false } } function k(r) { return function (u) { var v = u.length; for (var t = 0, s = this.entries.length; t < s; ++t) { u[v + t] = this.entries[t][r] } } } d.prototype = { getEqualityFunction: function (r) { return (typeof r.equals == p) ? g : e }, getEntryForKey: o(j), getEntryAndIndexForKey: o(f), removeEntryForKey: function (s) { var r = this.getEntryAndIndexForKey(s); if (r) { n(this.entries, r[0]); return r[1] } return null }, addEntry: function (r, s) { this.entries[this.entries.length] = [r, s] }, keys: k(0), values: k(1), getEntries: function (s) { var u = s.length; for (var t = 0, r = this.entries.length; t < r; ++t) { s[u + t] = this.entries[t].slice(0) } }, containsKey: o(h), containsValue: function (s) { var r = this.entries.length; while (r--) { if (s === this.entries[r][1]) { return true } } return false } }; function m(s, t) { var r = s.length, u; while (r--) { u = s[r]; if (t === u[0]) { return r } } return null } function i(r, s) { var t = r[s]; return (t && (t instanceof d)) ? t : null } function b(t, r) { var w = this; var v = []; var u = {}; var x = (typeof t == p) ? t : a; var s = (typeof r == p) ? r : null; this.put = function (B, C) { q(B); l(C); var D = x(B), E, A, z = null; E = i(u, D); if (E) { A = E.getEntryForKey(B); if (A) { z = A[1]; A[1] = C } else { E.addEntry(B, C) } } else { E = new d(D, B, C, s); v[v.length] = E; u[D] = E } return z }; this.get = function (A) { q(A); var B = x(A); var C = i(u, B); if (C) { var z = C.getEntryForKey(A); if (z) { return z[1] } } return null }; this.containsKey = function (A) { q(A); var z = x(A); var B = i(u, z); return B ? B.containsKey(A) : false }; this.containsValue = function (A) { l(A); var z = v.length; while (z--) { if (v[z].containsValue(A)) { return true } } return false }; this.clear = function () { v.length = 0; u = {} }; this.isEmpty = function () { return !v.length }; var y = function (z) { return function () { var A = [], B = v.length; while (B--) { v[B][z](A) } return A } }; this.keys = y("keys"); this.values = y("values"); this.entries = y("getEntries"); this.remove = function (B) { q(B); var C = x(B), z, A = null; var D = i(u, C); if (D) { A = D.removeEntryForKey(B); if (A !== null) { if (!D.entries.length) { z = m(v, C); n(v, z); delete u[C] } } } return A }; this.size = function () { var A = 0, z = v.length; while (z--) { A += v[z].entries.length } return A }; this.each = function (C) { var z = w.entries(), A = z.length, B; while (A--) { B = z[A]; C(B[0], B[1]) } }; this.putAll = function (H, C) { var B = H.entries(); var E, F, D, z, A = B.length; var G = (typeof C == p); while (A--) { E = B[A]; F = E[0]; D = E[1]; if (G && (z = w.get(F))) { D = C(F, z, D) } w.put(F, D) } }; this.clone = function () { var z = new b(t, r); z.putAll(w); return z } } return b })();
(function (k) { var a = new Hashtable(); var f = ["ae", "au", "ca", "cn", "eg", "gb", "hk", "il", "in", "jp", "sk", "th", "tw", "us"]; var b = ["at", "br", "de", "dk", "es", "gr", "it", "nl", "pt", "tr", "vn"]; var i = ["cz", "fi", "fr", "ru", "se", "pl"]; var d = ["ch"]; var g = [[".", ","], [",", "."], [",", " "], [".", "'"]]; var c = [f, b, i, d]; function j(n, l, m) { this.dec = n; this.group = l; this.neg = m } function h() { for (var l = 0; l < c.length; l++) { localeGroup = c[l]; for (var m = 0; m < localeGroup.length; m++) { a.put(localeGroup[m], l) } } } function e(l, r) { if (a.size() == 0) { h() } var q = "."; var o = ","; var p = "-"; if (r == false) { if (l.indexOf("_") != -1) { l = l.split("_")[1].toLowerCase() } else { if (l.indexOf("-") != -1) { l = l.split("-")[1].toLowerCase() } } } var n = a.get(l); if (n) { var m = g[n]; if (m) { q = m[0]; o = m[1] } } return new j(q, o, p) } k.fn.formatNumber = function (l, m, n) { return this.each(function () { if (m == null) { m = true } if (n == null) { n = true } var p; if (k(this).is(":input")) { p = new String(k(this).val()) } else { p = new String(k(this).text()) } var o = k.formatNumber(p, l); if (m) { if (k(this).is(":input")) { k(this).val(o) } else { k(this).text(o) } } if (n) { return o } }) }; k.formatNumber = function (q, w) { var w = k.extend({}, k.fn.formatNumber.defaults, w); var l = e(w.locale.toLowerCase(), w.isFullLocale); var n = l.dec; var u = l.group; var o = l.neg; var m = "0#-,."; var t = ""; var s = false; for (var r = 0; r < w.format.length; r++) { if (m.indexOf(w.format.charAt(r)) == -1) { t = t + w.format.charAt(r) } else { if (r == 0 && w.format.charAt(r) == "-") { s = true; continue } else { break } } } var v = ""; for (var r = w.format.length - 1; r >= 0; r--) { if (m.indexOf(w.format.charAt(r)) == -1) { v = w.format.charAt(r) + v } else { break } } w.format = w.format.substring(t.length); w.format = w.format.substring(0, w.format.length - v.length); var p = new Number(q); return k._formatNumber(p, w, v, t, s) }; k._formatNumber = function (m, q, n, I, t) { var q = k.extend({}, k.fn.formatNumber.defaults, q); var G = e(q.locale.toLowerCase(), q.isFullLocale); var F = G.dec; var w = G.group; var l = G.neg; var z = false; if (isNaN(m)) { if (q.nanForceZero == true) { m = 0; z = true } else { return null } } if (n == "%") { m = m * 100 } var B = ""; if (q.format.indexOf(".") > -1) { var H = F; var u = q.format.substring(q.format.lastIndexOf(".") + 1); if (q.round == true) { m = new Number(m.toFixed(u.length)) } else { var M = m.toString(); M = M.substring(0, M.lastIndexOf(".") + u.length + 1); m = new Number(M) } var A = m % 1; var C = new String(A.toFixed(u.length)); C = C.substring(C.lastIndexOf(".") + 1); for (var J = 0; J < u.length; J++) { if (u.charAt(J) == "#" && C.charAt(J) != "0") { H += C.charAt(J); continue } else { if (u.charAt(J) == "#" && C.charAt(J) == "0") { var r = C.substring(J); if (r.match("[1-9]")) { H += C.charAt(J); continue } else { break } } else { if (u.charAt(J) == "0") { H += C.charAt(J) } } } } B += H } else { m = Math.round(m) } var v = Math.floor(m); if (m < 0) { v = Math.ceil(m) } var E = ""; if (q.format.indexOf(".") == -1) { E = q.format } else { E = q.format.substring(0, q.format.indexOf(".")) } var L = ""; if (!(v == 0 && E.substr(E.length - 1) == "#") || z) { var x = new String(Math.abs(v)); var p = 9999; if (E.lastIndexOf(",") != -1) { p = E.length - E.lastIndexOf(",") - 1 } var o = 0; for (var J = x.length - 1; J > -1; J--) { L = x.charAt(J) + L; o++; if (o == p && J != 0) { L = w + L; o = 0 } } if (E.length > L.length) { var K = E.indexOf("0"); if (K != -1) { var D = E.length - K; var s = E.length - L.length - 1; while (L.length < D) { var y = E.charAt(s); if (y == ",") { y = w } L = y + L; s-- } } } } if (!L && E.indexOf("0", E.length - 1) !== -1) { L = "0" } B = L + B; if (m < 0 && t && I.length > 0) { I = l + I } else { if (m < 0) { B = l + B } } if (!q.decimalSeparatorAlwaysShown) { if (B.lastIndexOf(F) == B.length - 1) { B = B.substring(0, B.length - 1) } } B = I + B + n; return B }; k.fn.parseNumber = function (l, m, o) { if (m == null) { m = true } if (o == null) { o = true } var p; if (k(this).is(":input")) { p = new String(k(this).val()) } else { p = new String(k(this).text()) } var n = k.parseNumber(p, l); if (n) { if (m) { if (k(this).is(":input")) { k(this).val(n.toString()) } else { k(this).text(n.toString()) } } if (o) { return n } } }; k.parseNumber = function (s, x) { var x = k.extend({}, k.fn.parseNumber.defaults, x); var m = e(x.locale.toLowerCase(), x.isFullLocale); var p = m.dec; var v = m.group; var q = m.neg; var l = "1234567890.-"; while (s.indexOf(v) > -1) { s = s.replace(v, "") } s = s.replace(p, ".").replace(q, "-"); var w = ""; var o = false; if (s.charAt(s.length - 1) == "%" || x.isPercentage == true) { o = true } for (var t = 0; t < s.length; t++) { if (l.indexOf(s.charAt(t)) > -1) { w = w + s.charAt(t) } } var r = new Number(w); if (o) { r = r / 100; var u = w.indexOf("."); if (u != -1) { var n = w.length - u - 1; r = r.toFixed(n + 2) } else { r = r.toFixed(w.length - 1) } } return r }; k.fn.parseNumber.defaults = { locale: "us", decimalSeparatorAlwaysShown: false, isPercentage: false, isFullLocale: false }; k.fn.formatNumber.defaults = { format: "#,###.00", locale: "us", decimalSeparatorAlwaysShown: false, nanForceZero: true, round: true, isFullLocale: false }; Number.prototype.toFixed = function (l) { return k._roundNumber(this, l) }; k._roundNumber = function (n, m) { var l = Math.pow(10, m || 0); var o = String(Math.round(n * l) / l); if (m > 0) { var p = o.indexOf("."); if (p == -1) { o += "."; p = 0 } else { p = o.length - (p + 1) } while (p < m) { o += "0"; p++ } } return o } })(jQuery);